/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#define MF_SOURCE_NAME  MF_SOURCE_BI_GETHOSTNAME
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>
#include "mailfromd.h"
#include "prog.h"
#include "builtin.h"

#line 1 "bi_gethostname.m4"
/* This file is part of Mailfromd.             -*- c -*-
   Copyright (C) 2009 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef ENAMETOOLONG
# define ENAMETOOLONG 0
#endif

#ifndef INITIAL_HOSTNAME_LENGTH
# define INITIAL_HOSTNAME_LENGTH 34
#endif

#ifndef INITIAL_DOMAINNAME_LENGTH
# define INITIAL_DOMAINNAME_LENGTH 34
#endif

/* string gethostname()

   This implementation is based on xgethostname by Jim Meyering
*/
void
#line 33
bi_gethostname(eval_environ_t env)
#line 33

#line 33 "bi_gethostname.m4"
{
#line 33
	
#line 33

#line 33
long __bi_argcnt;
#line 33
long  dns;
#line 33
        
#line 33
get_numeric_arg(env, 1, &dns);
#line 33
        
#line 33
get_numeric_arg(env, 0, &__bi_argcnt);
#line 33
        adjust_stack(env, __bi_argcnt + 1);
#line 33

#line 33
	if (prog_trace_option & BUILTIN_MASK_gethostname)
#line 33
		prog_trace(env, "gethostname %lu",((__bi_argcnt > 0) ? dns : 0));;
#line 33

{
	size_t size = INITIAL_HOSTNAME_LENGTH;
	
	heap_obstack_begin(env);
	while (1) {
		size_t nsize;
		size_t size_1;
		char *hostname;

		heap_obstack_grow(env, NULL, size);
		hostname = heap_obstack_base(env);

                /* Use SIZE_1 here rather than SIZE to work around the bug in
		   SunOS 5.5's gethostname whereby it NUL-terminates HOSTNAME
		   even when the name is as long as the supplied buffer.  */
		size_1 = size - 1;
		hostname[size_1 - 1] = '\0';
		errno = 0;

		if (gethostname(hostname, size_1) == 0)	{
			if (!hostname[size_1 - 1])
				break;
		} else if (errno != 0
			   && errno != ENAMETOOLONG && errno != EINVAL
			   /* OSX/Darwin does this when the buffer is not
			      large enough */
			   && errno != ENOMEM) {
			int saved_errno = errno;
			heap_obstack_cancel(env);
				env_throw_bi(env, mfe_failure, "gethostname", "%s",mu_strerror(saved_errno));
#line 65
		}

		nsize = size * 2;
		if (nsize <= size) {
			heap_obstack_cancel(env);
				env_throw_bi(env, mfe_failure, "gethostname", "%s",mu_strerror(ENOMEM));
#line 72
		}
		size = nsize;
	}

	if (((__bi_argcnt > 0) ? dns : 0)) {
		struct hostent *hp;
		char *ptr = heap_obstack_base(env);
		
		hp = gethostbyname(ptr);
		if (hp) {
			size_t nlen = strlen(hp->h_name);
			if (nlen >= size)
				heap_obstack_grow(env, NULL, nlen - size + 1);
#line 86
			strcpy(ptr, hp->h_name);
		}
	}
	
	
#line 90
do {
#line 90
  push(env, (STKVAL) (heap_obstack_finish(env)));
#line 90
  return;
#line 90
} while (0);
}
}

/* string getdomainname()

   This implementation is based on xgetdomainname by Jim Meyering
*/
void
#line 98
bi_getdomainname(eval_environ_t env)
#line 98

#line 98 "bi_gethostname.m4"
{
#line 98
	
#line 98

#line 98

#line 98

#line 98

#line 98

#line 98
        adjust_stack(env, 0);
#line 98

#line 98
	if (prog_trace_option & BUILTIN_MASK_gethostname)
#line 98
		prog_trace(env, "getdomainname");;
#line 98

{
	size_t size = INITIAL_DOMAINNAME_LENGTH;
	
	heap_obstack_begin(env);
	while (1) {
		size_t nsize;
		size_t size_1;
		char *domainname;
		int rc;
		
		heap_obstack_grow(env, NULL, size);
		domainname = heap_obstack_base(env);

		size_1 = size - 1;
		domainname[size_1 - 1] = '\0';
		errno = 0;

		rc = getdomainname(domainname, size);
		if (rc >= 0 && domainname[size_1] == '\0')
			break;
		else if (rc < 0 && errno != EINVAL) {
			int saved_errno = errno;
			heap_obstack_cancel(env);
				env_throw_bi(env, mfe_failure, "getdomainname", "%s",mu_strerror(saved_errno));
#line 124
		}

		nsize = size * 2;
		if (nsize <= size) {
			heap_obstack_cancel(env);
				env_throw_bi(env, mfe_failure, "getdomainname", "%s",mu_strerror(ENOMEM));
#line 131
		}
		size = nsize;
	}
	
#line 134
do {
#line 134
  push(env, (STKVAL) (heap_obstack_finish(env)));
#line 134
  return;
#line 134
} while (0);
}
}
		

#line 138
void
#line 138
gethostname_init_builtin()
#line 138
{
#line 138
	#line 33 "bi_gethostname.m4"
va_builtin_install_ex("gethostname", bi_gethostname, 0, dtype_string, 1, 1, 0|0, dtype_number);
#line 98 "bi_gethostname.m4"
va_builtin_install_ex("getdomainname", bi_getdomainname, 0, dtype_string, 0, 0, 0|0, dtype_unspecified);

#line 138 "bi_gethostname.m4"
	
#line 138
}
#line 138

#line 625 "../mfd/snarf.m4"

#line 625

